import uoc.ei.tads.Iterador;
import uoc.ei.tads.ListaEncadenada;

public class Team {
	
	private String name;
	private int wins;
	private ListaEncadenada<Player> players=new ListaEncadenada<Player>();
	
	public Team(String name) {
		setName(name);
	}
	
	public String getName() {
		return name;
	}
	
	private void setName(String name) {
		this.name = name;
	}
	
	public int getWins() {
		return wins;
	}
	
	public void setWins(int wins) {
		this.wins = wins;
	}	
	
	public void addPlayer(Player player) {
		players.insertarAlFinal(player);
	}	
	
	public Iterador<Player> getPlayers(){
		return players.elementos();
	}
		
	public String toString() {
		return getName()+", ["+getWins()+"]";
	}
}