import uoc.ei.tads.DiccionarioVectorImpl;

public class Card implements Comparable<Card> {
	
	private static final int NUM_CARDS=13;
	private int value;
	private String name;
	private static DiccionarioVectorImpl<String, Integer> dicValues = new DiccionarioVectorImpl<String, Integer>(NUM_CARDS);
	
	private void init() {
		dicValues.insertar(new String("2"), new Integer(1));
		dicValues.insertar(new String("3"), new Integer(2));
		dicValues.insertar(new String("4"), new Integer(3));
		dicValues.insertar(new String("5"), new Integer(4));
		dicValues.insertar(new String("6"), new Integer(5));
		dicValues.insertar(new String("7"), new Integer(6));
		dicValues.insertar(new String("8"), new Integer(7));
		dicValues.insertar(new String("9"), new Integer(8));
		dicValues.insertar(new String("10"), new Integer(9));
		dicValues.insertar(new String("J"), new Integer(10));
		dicValues.insertar(new String("Q"), new Integer(11));
		dicValues.insertar(new String("K"), new Integer(12));
		dicValues.insertar(new String("A"), new Integer(13));
	}
	
	public Card(String nameCard) {
		init();
		setName(nameCard);
		setValue(dicValues.consultar(nameCard));
	}

	public int getValue() {
		return value;
	}

	private void setValue(int value) {
		this.value = value;
	}

	public String getName() {
		return name;
	}

	private void setName(String name) {
		this.name = name;
	}
	
	public int compareTo(Card card) {
		return this.getValue()-card.getValue();
	}
}