import uoc.ei.tads.Pila;
import uoc.ei.tads.PilaVectorImpl;

public class Example2 {
	
	public static void main(String args[]){
	
	/* Inicio inicialización */
		
		/* Se crea la baraja de cartas de póquer */
		Deck deck = new Deck();
		
		/* Se crean las cartas */
		Card h2=new HeartsCard("2");
		Card h3=new HeartsCard("3");
		Card hJ=new HeartsCard("J");
		Card c4=new ClubsCard("4");
		Card c6=new ClubsCard("6");
		Card sJ=new SpadesCard("J");
		Card sQ=new SpadesCard("Q");
		Card sK=new SpadesCard("K");
		Card d2=new DiamondsCard("2");
		Card dK=new DiamondsCard("K");
		Card dA=new DiamondsCard("A");
		
		/* Se añaden las cartas a la baraja */
		deck.addCard(h2);
		deck.addCard(sJ);
		deck.addCard(d2);
		deck.addCard(dK);
		deck.addCard(sK);
		deck.addCard(sQ);
		deck.addCard(h3);
		deck.addCard(c6);
		deck.addCard(hJ);
		deck.addCard(c4);
		deck.addCard(dA);
		
		/* Se crean cuatro pilas de cartas, una para cada uno de los palos
		 * de la bajara */
		Pila<ClubsCard> clubsCards=new PilaVectorImpl<ClubsCard>();
		Pila<DiamondsCard> diamondsCards=new PilaVectorImpl<DiamondsCard>();
		Pila<SpadesCard> spadesCards=new PilaVectorImpl<SpadesCard>();
		Pila<HeartsCard> heartsCards=new PilaVectorImpl<HeartsCard>();
	
	/* Fin inicialización */
	/* Inicio recorridos */
		
		/* Se muestra por pantalla cada una de las cartas de la bajara, 
		 * de forma ordenada. Además, en función de la naturaleza de cada 
		 * carta, se añade a la pila correspondiente del mismo palo
		 */
		System.out.print("Total cartas :\n\t");
		while (deck.numCards()>0) {
			Card aux=deck.getCard();
			System.out.print(aux.toString()+" ");
			if (aux instanceof ClubsCard) {
				clubsCards.apilar((ClubsCard)aux);
			} else if (aux instanceof DiamondsCard) {
				diamondsCards.apilar((DiamondsCard)aux);
			} else if (aux instanceof SpadesCard) {
				spadesCards.apilar((SpadesCard)aux);
			} else if (aux instanceof HeartsCard) {
				heartsCards.apilar((HeartsCard)aux);
			}
		}
		
		/* Se desapilan las cartas diamond y se muestran por pantalla */
		System.out.print("\n\nDiamons desapiladas :\n\t");		
		while (!diamondsCards.estaVacio()) {
			System.out.print(diamondsCards.desapilar()+" ");
		}
		
		/* Se desapilan las cartas spades y se muestran por pantalla */
		System.out.print("\n\nSpades desapiladas :\n\t");
		while (!spadesCards.estaVacio()) {
			System.out.print(spadesCards.desapilar()+" ");
		}
		
		/* Se desapilan las cartas hearts y se muestran por pantalla */
		System.out.print("\n\nHearts desapiladas :\n\t");
		while (!heartsCards.estaVacio()) {
			System.out.print(heartsCards.desapilar()+" ");
		}
		
		/* Se desapilan las cartas clubs y se muestran por pantalla */
		System.out.print("\n\nClubs desapiladas :\n\t");
		while (!clubsCards.estaVacio()) {
			System.out.print(clubsCards.desapilar()+" ");
		}
	/* Fin recorridos */
	}
}
